From ff21d91276c7e6a682610dd8b64507ada091683e Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 15 2020 00:01:32 +0000
Subject: [PATCH 1384/2232] Treat crate_dir creation as unsuccessful on non-unix non-windows


---

diff --git a/gen/build/src/out.rs b/gen/build/src/out.rs
index ac85184..157b316 100644
--- a/gen/build/src/out.rs
+++ b/gen/build/src/out.rs
@@ -60,7 +60,7 @@ pub(crate) fn symlink_dir(original: impl AsRef<Path>, link: impl AsRef<Path>) ->
         create_dir_error = fs::create_dir_all(parent).err();
     }
 
-    match paths::symlink_dir(original, link) {
+    match fs::symlink_dir(original, link) {
         // As long as symlink_dir succeeded, ignore any create_dir_all error.
         Ok(()) => Ok(()),
         // If create_dir_all and symlink_dir both failed, prefer the first error.
diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
index 6a8d352..effeec2 100644
--- a/gen/build/src/paths.rs
+++ b/gen/build/src/paths.rs
@@ -66,14 +66,6 @@ pub(crate) fn symlink_or_copy(
     Ok(())
 }
 
-#[cfg(any(unix, windows))]
-pub(crate) use self::fs::symlink_dir;
-
-#[cfg(not(any(unix, windows)))]
-pub(crate) fn symlink_dir(_original: impl AsRef<Path>, _link: impl AsRef<Path>) -> fs::Result<()> {
-    Ok(())
-}
-
 #[cfg(not(windows))]
 pub(crate) use self::fs::remove_file as remove_symlink_dir;
 
diff --git a/gen/src/fs.rs b/gen/src/fs.rs
index 7a6858c..7053cc4 100644
--- a/gen/src/fs.rs
+++ b/gen/src/fs.rs
@@ -9,7 +9,7 @@ pub(crate) type Result<T> = std::result::Result<T, Error>;
 
 #[derive(Debug)]
 pub(crate) struct Error {
-    source: io::Error,
+    source: Option<io::Error>,
     message: String,
 }
 
@@ -21,14 +21,15 @@ impl Display for Error {
 
 impl StdError for Error {
     fn source(&self) -> Option<&(dyn StdError + 'static)> {
-        Some(&self.source)
+        let source = self.source.as_ref()?;
+        Some(source)
     }
 }
 
 macro_rules! err {
     ($io_error:expr, $fmt:expr $(, $path:expr)* $(,)?) => {
         Err(Error {
-            source: $io_error,
+            source: Option::from($io_error),
             message: format!($fmt $(, $path.display())*),
         })
     }
@@ -106,10 +107,23 @@ fn symlink<'a>(
     }
 }
 
+pub(crate) fn symlink_fail(original: impl AsRef<Path>, link: impl AsRef<Path>) -> Result<()> {
+    err!(
+        None,
+        "Failed to create symlink `{}` pointing to `{}`",
+        link.as_ref(),
+        original.as_ref(),
+    )
+}
+
 #[cfg(unix)]
 #[allow(unused_imports)]
 pub(crate) use self::symlink_file as symlink_dir;
 
+#[cfg(not(any(unix, windows)))]
+#[allow(unused_imports)]
+pub(crate) use self::symlink_fail as symlink_dir;
+
 #[cfg(unix)]
 pub(crate) fn symlink_file(original: impl AsRef<Path>, link: impl AsRef<Path>) -> Result<()> {
     symlink(original.as_ref(), link.as_ref(), std::os::unix::fs::symlink)

